<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';

require_once HIS_APP . 'models/Login.php';
require_once HIS_APP . 'lib/Smarty/View.php';

class Backyard_AdminController extends Zend_Controller_Action 
{
public $module;
public $controller;

	/**
	 * initアクション
	 */
	public function init()
	{
		$req = $this->getRequest();

		$this->module		= $req->getModuleName();
		$this->controller	= $req->getControllerName();
		$this->action		= $req->getActionName();
		
		// PHPセッション開始
		session_start();
		
		switch ($this->action) 
		{
			case "index":	// ログイン画面
			case "login":	// ログイン処理
				// PHPセッション変数開放
				session_unset();
				return;
				break;
		}
		
		// セッション管理
		if (!isset($_SESSION['REC_ID'])) 
		{			
			if (isset($_COOKIE[session_name()])) 
				setcookie(session_name(), '', time()-42000, '/');
			
			// PHPセッション破棄
			session_destroy();
			
	  $this->_redirect("/{$this->module}/admin");
		}
//echo "module------------>{$req->getModuleName()}<P>";
//echo "ctrl------------>{$req->getControllerName()}<P>";
//echo "action------------>{$req->getActionName()}<P>";
	}

	/**
	 * ビューにSmartyを使用するサンプル
	 */
	public function indexAction()
	{
/*
echo "index start -----><PRE>";	
var_dump($_SERVER);
echo "</PRE>";
*/	

		//BASIC 認証済み？
		if(empty($_SERVER["PHP_AUTH_USER"])){
	  		$this->_redirect("/{$this->module}/");
		}//end if

		$title = "チャオモバイル簡易版 管理ツール";
		
		$view = new Smarty_View($this->module);
		
		$view->assign('title', $title);
		$view->showPage('template.tpl','AdminLogin');
	}

	/**
	 * ログイン認証アクション
	 */
	public function loginAction()
	{
		$param = Zend_Controller_Action::_getAllParams();
		
		$title = "チャオモバイル簡易版 管理ツール";

		//クリア時にデータをクリアする
		if(!empty($param['sub1']) && $param['sub1']=='クリア'){
			$view = new Smarty_View($this->module);
			$view->assign('title', $title);
			$view->showPage('template.tpl','AdminLogin');
			exit();
		}//end if
		
		// 入力チェック
		$Message = "";

		if(empty($param['LOGIN_ID'])){
			$Message .= "ログインIDを入力してください<br />";
		}//end if

		if(empty($param['PASS_WORD'])){
			$Message .= "パスワードを入力してください<br />";
		}//end if

		if (!empty($Message)) 
		{// 入力NG
		
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $title);
			$view->showPage('template.tpl','AdminLogin');
			return false;
		}

		// ログイン認証
		$rese = new Login();
		$db = $rese->getAdapter();
		$where	= array(
						$db->quoteInto('LOGIN_ID = ?', $param['LOGIN_ID']),
						$db->quoteInto('PASS_WORD = ?', $param['PASS_WORD'])
					);
		$row = $rese->fetchRow($where);

		if (!empty($row['REC_ID'])) 
		{// 認証OK
		
			// ログイン情報の格納
			$_SESSION = array(
							'REC_ID'		=> $row['REC_ID'],
							'LOGIN_ID'		=> $row['LOGIN_ID'],
							'LOGIN_NAME'	=> $row['LOGIN_NAME'],
							'PASS_WORD'		=> $row['PASS_WORD'],
						);

			$this->_redirect("/{$this->module}/");
		} else 
		{// 認証NG
		
			$Message = "正しく入力してください<br />";
			
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $title);
			$view->showPage('template.tpl','AdminLogin');
			return false;
		}
	}

	/**
	 * パスワード変更入力画面表示アクション
	 */
	public function passwordinputAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$title = "メニュー > パスワードの変更";
		
		$pankuzu  = "<a href=\"/his/{$this->module}/\">メニュー</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "パスワード変更";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', $title);
		$view->assign("pankuzu", $pankuzu);
		$view->showPage('template.tpl','PasswordInput');
	}

	/**
	 * パスワード変更（認証）アクション
	 */
	public function passwordeditAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$title = "メニュー > パスワードの変更";
		
		$pankuzu  = "<a href=\"/his/{$this->module}/\">メニュー</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "パスワード変更";
		
		// 入力チェック
		$Message = "";

		if(empty($param['OLD_PASS_WORD'])){
			$Message .= "現在のパスワードを入力してください<br />";
		}//end if

		if(empty($param['NEW_PASS_WORD'])){
			$Message .= "新しいパスワードを入力してください<br />";
		}elseif($param['NEW_PASS_WORD'] != $param['NEW_PASS_WORD_CONF']){;
			$Message .= "新しいパスワード（確認）が一致しません<br />";
		}//end if

		if (!empty($Message)) 
		{// 入力NG
		
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $title);
			$view->assign("pankuzu", $pankuzu);
			$view->showPage('template.tpl','PasswordInput');
			return false;
		}

		// パスワード認証
		$rese = new Login();
		$db = $rese->getAdapter();
		$where	= array(
						$db->quoteInto('REC_ID = ?', $_SESSION['REC_ID']),
						$db->quoteInto('PASS_WORD = ?', $param['OLD_PASS_WORD'])
					);
		$row = $rese->fetchRow($where);
		
		if (empty($row['REC_ID'])) 
		{// 認証NG
		
			$Message = "現在のパスワードが違います<br />";
			
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $title);
			$view->assign("pankuzu", $pankuzu);
			$view->showPage('template.tpl','PasswordInput');
			return false;
		}
		
		// パスワード変更処理
		$row = array(
				'PASS_WORD'		=> $param['NEW_PASS_WORD'],
				'UPDATE_TIME'	=> date('Y/m/d H:i:s')
				);
		
		$where = $db->quoteInto('REC_ID = ?', $_SESSION['REC_ID']);
		$key = $rese->update($row, $where);
		
		$_SESSION['PASS_WORD'] = $param['NEW_PASS_WORD'];
		
		$this->_redirect("/{$this->module}/{$this->controller}/passwordcomp/");
	}

	/**
	 * パスワード変更完了画面表示アクション
	 */
	public function passwordcompAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$title = "メニュー > パスワードの変更";
		
		$pankuzu  = "<a href=\"/his/{$this->module}/\">メニュー</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "パスワード変更";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', $title);
		$view->assign("pankuzu", $pankuzu);
		$view->showPage('template.tpl','PasswordComplete');
	}

	/**
	 * アクション名が見つからない
	 */
	public function __call($methodName, $args)
	{
		$param = Zend_Controller_Action::_getAllParams();
		$this->_redirect("/{$param['controller']}/");
	}
}
