<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';

require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP . 'models/Reserve.php';
require_once HIS_APP.'lib/Smarty/View.php';

class Backyard_ReserveController extends Zend_Controller_Action 
{
public $module;
public $controller;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
    }

    /**
     * デフォルトアクション
     */
    public function indexAction()
    {
        // パラメータを取得
       $param = Zend_Controller_Action::_getAllParams();

	$status=$param['STATUS'];
echo "<pre>";
var_dump($status);
echo "</pre>";

	$cond = "";
	foreach($status as $key=>$STATUS){
		if($key != 0){
			$cond .=" OR R.STATUS = {$STATUS}";
		}else{
			$cond = "R.STATUS = {$STATUS}";
		}//end if
	}//end foreach

	echo "COND---->{$cond}<P>";

        $rese = new Reserve();
        $db = $rese->getAdapter();
	$sql="SELECT T.TOUR_CODE as TOUR_CODE,T.TOUR_NAME as TOUR_NAME,
		S.SCHEDULE_DATE as SCHEDULE_DATE,R.*
		FROM T_RESERVE as R,M_TOURPACKAGE as T,M_TOURPACKAGE_SCHEDULE as S 
		WHERE T.TOUR_ID=R.TOUR_ID AND R.SCHEDULE_ID=S.SCHEDULE_ID AND ({$cond})
		ORDER BY RESERVE_ID";

echo "SQL--->{$sql}<P>";
        $rows = $db->fetchAll($sql);

//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $rows);
       $view->showPage('template.tpl','ReserveList');


    }

    /**
     * 予約詳細表示アクション
     */
    public function detailAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

	//代表者情報
       $rese = new Reserve();
       $db1 = $rese->getAdapter();
	$sql1="SELECT T.TOUR_CODE as TOUR_CODE,T.TOUR_NAME as TOUR_NAME,
		S.SCHEDULE_DATE as SCHEDULE_DATE,R.*
		FROM T_RESERVE as R,M_TOURPACKAGE as T,M_TOURPACKAGE_SCHEDULE as S 
		WHERE T.TOUR_ID=R.TOUR_ID AND R.SCHEDULE_ID=S.SCHEDULE_ID 
		AND R.RESERVE_ID={$param['R_ID']}";

echo "SQL--->{$sql1}<P>";
        $row1 = $db1->fetchAll($sql1);
echo "<pre>".var_dump($row1)."</pre><P>";
echo "COMPANION_MAX--->{$row1[0]['COMPANION_MAX']}<P>";

	//同行者情報
       $comp = new Companion();
       $db2 = $comp->getAdapter();
	$sql2="SELECT * FROM T_RESERVE_COMPANION WHERE RESERVE_ID={$param['R_ID']}
		AND COMPANION_NO <= {$row1[0]['COMPANION_MAX']} ORDER BY COMPANION_NO";
echo "SQL2--->{$sql2}<P>";
        $row2 = $db2->fetchAll($sql2);

//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param1", $row1);
	$view->assign("param2", $row2);
       $view->showPage('template.tpl','ReserveDetail');

    }

    /**
     * ステータス変更確認アクション
     */
    public function changeconfAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
       $view->showPage('template.tpl','S_ChangeConfirm');

    }

    /**
     * ステータス変更アクション
     */
    public function statuschangeAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
$p = array('host' => $config->database->host,
                'username' => $config->database->username,
                'password' => $config->database->password,
                'dbname' => $config->database->name);

print_r($p);

	switch($param['STATUS']){
	case 'HORYU':
			$status =$config->status->horyu;
			break;
	case 'CANCEL':
			$status =$config->status->cancel;
			break;
	case 'COMPLETE':
			$status =$config->status->complete;
			break;
	default:
			$status =$config->status->reserve;
			break;
	}//end switch


      // 代表者のSTATUSを更新
        $rese = new Reserve();
        $row = array (
		'STATUS'	=>$status,
		'UPDATE_TIME'	=> date('Y/m/d H:i:s')
                 );
        $db = $rese->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $key = $rese->update($row, $where);


	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
       $view->showPage('template.tpl','S_ChangeComplete');

    }

    /**
     * スタッフ入力画面表示アクション
     */
    public function staffinputAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
       $view->showPage('template.tpl','StaffInput');

    }

    /**
     * スタッフ入力画面表示アクション
     */
    public function staffconfAction()
    {

       $param = Zend_Controller_Action::_getAllParams();
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $param);
       $view->showPage('template.tpl','StaffConfirm');

    }

    /**
     * ステータス変更アクション
     */
    public function staffcompAction()
    {

       $param = Zend_Controller_Action::_getAllParams();

	if(!empty($param['STAFF_NAME']) AND !empty($param['R_ID']))
	{
      // 担当者を登録
        $rese = new Reserve();
        $row = array (
		'STAFF_NAME'	=>$param['STAFF_NAME'],
		'UPDATE_TIME'	=> date('Y/m/d H:i:s')
                 );
        $db = $rese->getAdapter();
        $where = $db->quoteInto('RESERVE_ID = ?', $param['R_ID']);
        $key = $rese->update($row, $where);

	$Message="";

	}else{

	$Message="担当者を入力してください";

	}//end if

	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("Message", $Message);
	$view->assign("param", $param);
       $view->showPage('template.tpl','StaffComplete');


    }


    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
        $view = new My_View();
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }
}



