<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP.'lib/Smarty/View.php';

class Backyard_SummaryController extends Zend_Controller_Action 
{
public $module;
public $controller;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();
		
		// PHPセッション開始
		session_start();
		
		// セッション管理
		if (!isset($_SESSION['REC_ID'])) 
		{
			
			if (isset($_COOKIE[session_name()])) 
				setcookie(session_name(), '', time()-42000, '/');
			
			// PHPセッション破棄
			session_destroy();
			
			$this->_redirect("/{$this->module}/admin");
		}
//echo "module------------>{$req->getModuleName()}<P>";
//echo "ctrl------------>{$req->getControllerName()}<P>";
//echo "action------------>{$req->getActionName()}<P>";
    }

    /**
     * デフォルトアクション
     */
    public function indexAction()
    {

        // 全ての行を取得
       $param = Zend_Controller_Action::_getAllParams();

	$tour = new Tour();
	
	$rows = $tour->fetchAll()->toArray();
	
		$title = "メニュー > 集客状況ツアー選択";
		
		$pankuzu  = "<a href=\"/his/{$this->module}/\">メニュー</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "集客状況ツアー選択";
	
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("param", $rows);
	$view->assign('title', $title);
	$view->assign('pankuzu', $pankuzu);
	$view->showPage('template.tpl','SummarySelect');

    }

  
   /**
     * 集計表示アクション
     */
    public function summarylistAction()
    {

        // パラメータを取得
       $param = Zend_Controller_Action::_getAllParams();

       // ツアー情報を取得
       $tour = new Tour();
       $db = $tour->getAdapter();
       $where = $db->quoteInto('TOUR_ID= ?', $param['T_ID']);
       $row = $tour->fetchRow($where)->toArray();


	//日程データの表示
        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();

	$sql="SELECT SCHEDULE_DATE,SCHEDULE_DEFAULT_HEADCOUNT,
		SCHEDULE_DEFAULT_HEADCOUNT-SCHEDULE_HEADCOUNT as RESERVE,
		SCHEDULE_HEADCOUNT 
		FROM M_TOURPACKAGE_SCHEDULE WHERE TOUR_ID={$param['T_ID']}
		ORDER BY SCHEDULE_DATE";

        $rows = $db->fetchAll($sql);
	
		$title = "メニュー > 集客状況ツアー選択 > 集客状況表示";
		
		$pankuzu  = "<a href=\"/his/{$this->module}/\">メニュー</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "<a href=\"/his/{$this->module}/{$this->controller}\">集客状況ツアー選択</a>";
		$pankuzu .= "&nbsp;&gt;&nbsp;";
		$pankuzu .= "集客状況表示";
	
	//Smartyに連想配列を渡す（assignする）
	$view = new Smarty_View($this->module);
	$view->assign("tour", $row);
	$view->assign("param", $rows);
	$view->assign('title', $title);
	$view->assign('pankuzu', $pankuzu);
	$view->showPage('template.tpl','SummaryList');

    }




    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }
}



