<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP.'lib/Smarty/View.php';

class Backyard_TourController extends Zend_Controller_Action 
{
public $module;
public $controller;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

//echo "module------------>{$req->getModuleName()}<P>";
//echo "ctrl------------>{$req->getControllerName()}<P>";
//echo "action------------>{$req->getActionName()}<P>";
    }

	/**
	 * デフォルトアクション
	 */
	public function indexAction()
	{

		// 全ての行を取得
		$param = Zend_Controller_Action::_getAllParams();

		$tour = new Tour();
		$db = $tour->getAdapter();
		
		$sql  = "SELECT ";
		$sql .= "		a.*, ";
		$sql .= "		COUNT(b.TOUR_ID) AS RESERVE_COUNT ";
		$sql .= "	FROM ";
		$sql .= "		M_TOURPACKAGE AS a ";
		$sql .= "	LEFT JOIN ";
		$sql .= "		T_RESERVE AS b ";
		$sql .= "	ON ";
		$sql .= "			a.TOUR_ID = b.TOUR_ID";
		$sql .= "	GROUP BY ";
		$sql .= "		a.TOUR_ID ";
		$sql .= "	ORDER BY ";
		$sql .= "		a.TOUR_ID DESC ";

		$rows = $db->fetchAll($sql);
		
		//Smartyに連想配列を渡す（assignする）
		$view = new Smarty_View($this->module);
		$view->assign("param", $rows);
		$view->assign('title', '管理ツール > ツアー一覧ページ');
		$view->showPage('template.tpl','TourSelect');
	}

   /**
     * edit Dispアクション
     */
    public function editdispAction()
    {

        // 全ての行を取得
       $param = Zend_Controller_Action::_getAllParams();

//echo "key------------>{$param['key']}<P>";

	$view = new Smarty_View($this->module);
/*
	$view->assign("module", $req->getModuleName());
	$view->assign("ctrl", $req->getControllerName());
	$view->assign("action", $req->getActionName());
        $view->showPage('template.tpl','user');
*/
        $mssg = new Tour();
        $rows = $mssg->fetchAll()->toArray();
//Smartyに連想配列を渡す（assignする）
	$view->assign("Rows", $rows);
        $view->showPage('template.tpl','DbList');


    }

    /**
     * editアクション
     */
    public function editAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

        $view = new Smarty_View($this->module);

        $view->pageTitle = "{$param['controller']} Sample";

        // 指定したidの行を取得
        $mssg = new Tour();
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $row = $mssg->fetchRow($where)->toArray();
	 $view->assign("messages", $row);
        $view->showPage('template.tpl','DbEdit');
    }

    /**
     * データ入力画面表示
     */
    public function inputAction()
    {
 
//View 
        $view = new Smarty_View($this->module);
 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();

		$param['TOUR_ID']		= isset($param['TOUR_ID']) ? $param['TOUR_ID'] : "";
		$param['TOUR_ID']		= isset($param['T_ID']) && !$param['TOUR_ID'] ? $param['T_ID'] : $param['TOUR_ID'];
		$param['MODE']			= isset($param['MODE']) ? $param['MODE'] : "";
		$param['BACK_FLG']		= isset($param['BACK_FLG']) ? $param['BACK_FLG'] : "";
		
		if($param['MODE'] == "edit" && !$param['BACK_FLG'] && $param['TOUR_ID']){
		// 編集モード初期アクセス時
			
			$rese = new Tour();
			$db = $rese->getAdapter();
			$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
			$t_row = $rese->fetchRow($where)->toArray();
			
			$param['T_ID']					= $t_row['TOUR_ID'];
			$param['T_CODE']				= $t_row['TOUR_CODE'];
			$param['T_NAME']				= $t_row['TOUR_NAME'];
			$param['T_COMMENT']				= $t_row['TOUR_COMMENT'];
			$param['T_URL']					= $t_row['TOUR_URL'];
			$param['T_IMG']					= $t_row['TOUR_IMG'];
			$param['AVAILABLE_DAYS_FROM']	= $t_row['AVAILABLE_DAYS_FROM'];
			$param['AVAILABLE_DAYS_TO']		= $t_row['AVAILABLE_DAYS_TO'];
			$param['T_DEFAULT_PRICE']		= $t_row['TOUR_DEFAULT_PRICE'];
			$param['T_DEFAULT_HEADCOUNT']	= $t_row['TOUR_DEFAULT_HEADCOUNT'];
			$param['T_DEFAULT_HEADCOUNT']	= $t_row['TOUR_DEFAULT_HEADCOUNT'];
			$param['T_DEFAULT_MAX']			= $t_row['TOUR_DEFAULT_MAX'];
			$param['T_DEFAULT_MINI']		= $t_row['TOUR_DEFAULT_MINI'];
			$param['T_DEFAULT_THREE']		= $t_row['TOUR_DEFAULT_THREE'];
			$param['T_DEFAULT_FIVE']		= $t_row['TOUR_DEFAULT_FIVE'];
			$param['T_DEFAULT_ODD']			= $t_row['TOUR_DEFAULT_ODD'];
		}
		
		$tirle_str = $param['MODE'] == "edit" ? "ツアーの編集" : "ツアーの登録";

        $view->assign('param', $param);
        $view->assign('title', $tirle_str);
        $view->showPage('template.tpl','TourInput');

    }

  /**
     * データ確認画面表示
     */
    public function confirmAction()
    {
 
 //Smartyに連想配列を渡す（assignする）
        $param = Zend_Controller_Action::_getAllParams();
		
		$tirle_str = $param['MODE'] == "edit" ? "ツアーの編集" : "ツアーの登録";
		
		// Mime Tyep 配列設定
		$ExtTypes = array( 
			'image/jpeg'	=>'.jpg',
			'image/gif'		=>'.gif',
			'image/png'		=>'.png',
			'image/x-bmp'	=>'.bmp',
			);
		
		// 入力チェック
		$Message = "";
		
		// ツアーコード
		if(empty($param['T_CODE'])){
			$Message .= "ツアーコードを入力してください<br />";
		}//end if
		
		// ツアー名
		if(empty($param['T_NAME'])){
			$Message .= "ツアー名を入力してください<br />";
		}//end if
		
		// ツアーコメント
		if(empty($param['T_COMMENT'])){
			$Message .= "ツアーコメントを入力してください<br />";
		}//end if
		
		// ツアーページURL
		if(empty($param['T_URL'])){
			$Message .= "ツアーページURLを入力してください<br />";
		}elseif($this->strMatching($param['T_URL'], "URL")){
			$Message .= "ツアーページURLを正しく入力してください<br />";
		}//end if
		
		// 有効期限（開始日）
		if(empty($param['AVAILABLE_DAYS_FROM'])){
			//NULL許可
		}elseif($this->strMatching($param['AVAILABLE_DAYS_FROM'], "DATE")){
			$Message .= "有効期限（開始日）は半角数字といくつかの記号でのみ入力してください<br />";
		}//end if
		
		// 有効期限（終了日）
		if(empty($param['AVAILABLE_DAYS_TO'])){
			//NULL許可
		}elseif($this->strMatching($param['AVAILABLE_DAYS_TO'], "DATE")){
			$Message .= "有効期限（終了日）は半角数字といくつかの記号でのみ入力してください<br />";
		}//end if
		
		// ツアー画像
		if(empty($_FILES["img_path"]["tmp_name"])){
			//NULL許可
		}elseif(!$ExtTypes[$_FILES['img_path']['type']]){
			$Message .= "ツアー画像の形式が正しく入力してください<br />";
		}//end if
		
		// ツアー価格
		if(empty($param['T_DEFAULT_PRICE'])){
//			$Message .= "ツアー価格を入力してください<br />";
		}elseif($this->strMatching($param['T_DEFAULT_PRICE'], "NUM")){
			$Message .= "ツアー価格は半角数字で入力してください<br />";
		}//end if
		
		// ツアー募集人数
		if(empty($param['T_DEFAULT_HEADCOUNT'])){
//			$Message .= "ツアー募集人数を入力してください<br />";
		}elseif($this->strMatching($param['T_DEFAULT_HEADCOUNT'], "NUM")){
			$Message .= "ツアー募集人数は半角数字で入力してください<br />";
		}//end if
		
		// ツアー最大人数
		if(empty($param['T_DEFAULT_MAX'])){
//			$Message .= "ツアー最大人数を入力してください<br />";
		}elseif($this->strMatching($param['T_DEFAULT_MAX'], "NUM")){
			$Message .= "ツアー最大人数は半角数字で入力してください<br />";
		}//end if
		
		// ツアー最少人数
		if(empty($param['T_DEFAULT_MINI'])){
//			$Message .= "ツアー最少人数を入力してください<br />";
		}elseif($this->strMatching($param['T_DEFAULT_MINI'], "NUM")){
			$Message .= "ツアー最大人数は半角数字で入力してください<br />";
		}//end if
		
		if (!empty($Message)) 
		{// 入力NG
		
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $tirle_str);
			$view->showPage('template.tpl','TourInput');
			return false;
		}
		
/*
	 $sess = new Zend_Session_Namespace('TOUR');
	 $sess->__set('para',$param['T_CODE']);
*/
		// 画像アップロード
		if($_FILES["img_path"]["tmp_name"]){
		
			$img_temp = $_FILES['img_path']['tmp_name'] . $ExtTypes[$_FILES['img_path']['type']];
			$img_path = $_SERVER['DOCUMENT_ROOT'] . "/his/HIS_App/images";
			move_uploaded_file($_FILES['img_path']['tmp_name'], $img_path . $img_temp);
			
			$param['IMG_TEMP'] = $img_temp;
		}

//View 
        $view = new Smarty_View($this->module);

        $view->assign('title', $tirle_str);
        $view->assign('param', $param);
        $view->showPage('template.tpl','TourConf');

    }

    /**
     * insertアクション
     */
    public function insertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();
/*
	  $sess = new Zend_Session_Namespace('TOUR');
	  $p= $sess->__get('para');
	 
echo "<PRE>";
var_dump($p);
echo "</PRE>";
*/

	
	 //CHECK & SET PARAM CLASS 
	//TEMP EASY CHECK 2008/12/22

	//SET PARAM
	
        $row = array (
		'TOUR_CODE' 	=> $param['T_CODE'],
		'TOUR_NAME' 	=> $param['T_NAME'],
		'TOUR_COMMENT'=> $param['T_COMMENT'],
		'CREATE_TIME'	=> date('Y/m/d H:i:s')
                 );

	if(!empty($param['T_URL'])){
		$row['TOUR_URL'] 	= $param['T_URL'];
	}//end if

	if(!empty($param['T_IMG'])){
		$row['TOUR_IMG']	= $param['T_IMG'];
	}//end if

	if(!empty($param['AVAILABLE_DAYS_FROM'])){
		$row['AVAILABLE_DAYS_FROM']	= $param['AVAILABLE_DAYS_FROM'];
	}//end if

	if(!empty($param['AVAILABLE_DAYS_TO'])){
		$row['AVAILABLE_DAYS_TO']	= $param['AVAILABLE_DAYS_TO'];
	}//end if

	if(!empty($param['T_DEFAULT_PRICE'])){
		$row['TOUR_DEFAULT_PRICE']	= $param['T_DEFAULT_PRICE'];
	}//end if

	if(!empty($param['T_DEFAULT_HEADCOUNT'])){
		$row['TOUR_DEFAULT_HEADCOUNT'] = $param['T_DEFAULT_HEADCOUNT'];
	}//end if

	if(!empty($param['T_DEFAULT_MAX'])){
		$row['TOUR_DEFAULT_MAX']	= $param['T_DEFAULT_MAX'];
	}//end if

	if(!empty($param['T_DEFAULT_MINI'])){
		$row['TOUR_DEFAULT_MINI']	= $param['T_DEFAULT_MINI'];
	}//end if

	if(!empty($param['T_DEFAULT_THREE'])){
		$row['TOUR_DEFAULT_THREE'] 	= $param['T_DEFAULT_THREE'];
	}//end if

	if(!empty($param['T_DEFAULT_FIVE'])){
		$row['TOUR_DEFAULT_FIVE']		= $param['T_DEFAULT_FIVE'];
	}//end if

	if(!empty($param['T_DEFAULT_ODD'])){
		$row['TOUR_DEFAULT_ODD']		= $param['T_DEFAULT_ODD'];
	}//end if

		$row['TOUR_DEFAULT_THREE']	= isset($row['TOUR_DEFAULT_THREE']) ? "1" : "0";
		$row['TOUR_DEFAULT_FIVE']	= isset($row['TOUR_DEFAULT_FIVE']) ? "1" : "0";
		$row['TOUR_DEFAULT_ODD']	= isset($row['TOUR_DEFAULT_ODD']) ? "1" : "0";
/*
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/
        // 行の挿入

        $tour = new Tour();
        $key=$tour->insert($row);

		// 画像アップロード
		if(isset($param['IMG_TEMP'])){
		
			$img_name = "IMG" . STR_PAD($key, 10, "0", STR_PAD_LEFT) . substr($param['IMG_TEMP'], -4);
			$img_path = $_SERVER['DOCUMENT_ROOT'] . "/his/HIS_App/images";
			
			rename($img_path . $param['IMG_TEMP'], $img_path . "/" . $img_name);
			
			$tour = new Tour();
			$db = $tour->getAdapter();
			$set = array('TOUR_IMG' => $img_name);
			$where = $db->quoteInto('TOUR_ID = ?', $key);
			$key2 = $tour->update($set, $where);
		}
/*
echo "{$key}  が登録されました<P>";
echo "{$param['controller']}<P>";
*/
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', "ツアーの登録");
        $view->assign('T_ID', $key);
        $view->assign('param', $param);
        $view->showPage('template.tpl','TourComplete');

        //$this->_redirect("/{$this->module}/{$this->controller}");
    }

    /**
     * updateアクション
     */
    public function updateAction()
    {
         $param = Zend_Controller_Action::_getAllParams();
/*
	  $sess = new Zend_Session_Namespace('TOUR');
	  $p= $sess->__get('para');
	 
echo "<PRE>";
var_dump($p);
echo "</PRE>";
*/

	
	 //CHECK & SET PARAM CLASS 
	//TEMP EASY CHECK 2008/12/22

	//SET PARAM
	
        $row = array (
		'TOUR_CODE' 	=> $param['T_CODE'],
		'TOUR_NAME' 	=> $param['T_NAME'],
		'TOUR_COMMENT'=> $param['T_COMMENT'],
		'UPDATE_TIME'	=> date('Y/m/d H:i:s')
                 );

	if(!empty($param['T_URL'])){
		$row['TOUR_URL'] 	= $param['T_URL'];
	}//end if

	if(!empty($param['T_IMG'])){
		$row['TOUR_IMG']	= $param['T_IMG'];
	}//end if

	if(!empty($param['AVAILABLE_DAYS_FROM'])){
		$row['AVAILABLE_DAYS_FROM']	= $param['AVAILABLE_DAYS_FROM'];
	}//end if

	if(!empty($param['AVAILABLE_DAYS_TO'])){
		$row['AVAILABLE_DAYS_TO']	= $param['AVAILABLE_DAYS_TO'];
	}//end if

	if(!empty($param['T_DEFAULT_PRICE'])){
		$row['TOUR_DEFAULT_PRICE']	= $param['T_DEFAULT_PRICE'];
	}//end if

	if(!empty($param['T_DEFAULT_HEADCOUNT'])){
		$row['TOUR_DEFAULT_HEADCOUNT'] = $param['T_DEFAULT_HEADCOUNT'];
	}//end if

	if(!empty($param['T_DEFAULT_MAX'])){
		$row['TOUR_DEFAULT_MAX']	= $param['T_DEFAULT_MAX'];
	}//end if

	if(!empty($param['T_DEFAULT_MINI'])){
		$row['TOUR_DEFAULT_MINI']	= $param['T_DEFAULT_MINI'];
	}//end if

	if(!empty($param['T_DEFAULT_THREE'])){
		$row['TOUR_DEFAULT_THREE'] 	= $param['T_DEFAULT_THREE'];
	}//end if

	if(!empty($param['T_DEFAULT_FIVE'])){
		$row['TOUR_DEFAULT_FIVE']		= $param['T_DEFAULT_FIVE'];
	}//end if

	if(!empty($param['T_DEFAULT_ODD'])){
		$row['TOUR_DEFAULT_ODD']		= $param['T_DEFAULT_ODD'];
	}//end if

//		if(!isset($row['AVAILABLE_DAYS_FROM']))	$row['AVAILABLE_DAYS_FROM'] = new Zend_Db_Expr('NULL');
//		if(!isset($row['AVAILABLE_DAYS_TO']))	$row['AVAILABLE_DAYS_TO'] = new Zend_Db_Expr('NULL');
//		if(!isset($row['T_DEFAULT_HEADCOUNT']))	$row['T_DEFAULT_HEADCOUNT'] = new Zend_Db_Expr('NULL');
//		if(!isset($row['T_DEFAULT_MAX']))		$row['T_DEFAULT_MAX'] = new Zend_Db_Expr('NULL');
//		if(!isset($row['T_DEFAULT_MINI']))		$row['T_DEFAULT_MINI'] = new Zend_Db_Expr('NULL');

		$row['TOUR_DEFAULT_THREE']	= isset($row['TOUR_DEFAULT_THREE']) ? "1" : "0";
		$row['TOUR_DEFAULT_FIVE']	= isset($row['TOUR_DEFAULT_FIVE']) ? "1" : "0";
		$row['TOUR_DEFAULT_ODD']	= isset($row['TOUR_DEFAULT_ODD']) ? "1" : "0";
/*
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/
		// 画像アップロード
		if(isset($param['IMG_TEMP'])){
		
			$img_name = "IMG" . STR_PAD($param['T_ID'], 10, "0", STR_PAD_LEFT) . substr($param['IMG_TEMP'], -4);
			$img_path = $_SERVER['DOCUMENT_ROOT'] . "/his/HIS_App/images";
			
			rename($img_path . $param['IMG_TEMP'], $img_path . "/" . $img_name);
			
			$row['TOUR_IMG'] = $img_name;
		}
		
		// 行の更新
		
		$tour = new Tour();
		$db = $tour->getAdapter();
		$set = $row;
		$where = $db->quoteInto('TOUR_ID = ?', $param['T_ID']);
		$key = $tour->update($set, $where);
/*
echo "{$key}  が編集されました<P>";
echo "{$param['controller']}<P>";
*/
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', "ツアーの編集");
        $view->assign('T_ID', $key);
        $view->assign('param', $param);
        $view->showPage('template.tpl','TourComplete');

        //$this->_redirect("/{$this->module}/{$this->controller}");
    }

   /**
     * 日程データ入力画面表示
     */
    public function scheduleinputAction()
    {
	
		$param = Zend_Controller_Action::_getAllParams();
		
		$param['TOUR_ID']		= isset($param['TOUR_ID']) ? $param['TOUR_ID'] : $param['T_ID'];
		$param['SCHEDULE_ID']	= isset($param['SCHEDULE_ID']) ? $param['SCHEDULE_ID'] : "";
		$param['MODE']			= isset($param['MODE']) ? $param['MODE'] : "";
		$param['BACK_FLG']		= isset($param['BACK_FLG']) ? $param['BACK_FLG'] : "";
		
		if($param['TOUR_ID']){
		
			$rese = new Tour();
			$db = $rese->getAdapter();
			$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
			$t_row = $rese->fetchRow($where)->toArray();
			
			$param['T_ID']		= $t_row['TOUR_ID'];
			$param['T_CODE']	= $t_row['TOUR_CODE'];
			$param['T_NAME']	= $t_row['TOUR_NAME'];
		}
		
		if($param['MODE'] == "edit" && !$param['BACK_FLG'] && $param['TOUR_ID'] && $param['SCHEDULE_ID']){
		// 編集モード初期アクセス時
		
			$rese = new Tour_Schedule();
			$db = $rese->getAdapter();
			$where = array(
						$db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']),
						$db->quoteInto('SCHEDULE_ID = ?', $param['SCHEDULE_ID']),
					);
			$s_row = $rese->fetchRow($where);
			
			$param['S_DATE']		= $s_row['SCHEDULE_DATE'];
			$param['S_PRICE']		= $s_row['SCHEDULE_PRICE'];
			$param['S_HEADCOUNT']	= $s_row['SCHEDULE_DEFAULT_HEADCOUNT'];
			$param['S_MAX']			= $s_row['SCHEDULE_MAX'];
			$param['S_MINI']		= $s_row['SCHEDULE_MINI'];
			$param['S_THREE']		= $s_row['SCHEDULE_THREE'];
			$param['S_FIVE']		= $s_row['SCHEDULE_FIVE'];
			$param['S_ODD']			= $s_row['SCHEDULE_ODD'];
			
			if(empty($s_row['SCHEDULE_ID'])) $param['MODE'] = "";
			
		}elseif($param['MODE'] != "edit" && !$param['BACK_FLG'] && $param['TOUR_ID']){
		// 登録モード初期アクセス時
		
			$param['S_PRICE']		= $t_row['TOUR_DEFAULT_PRICE'];
			$param['S_HEADCOUNT']	= $t_row['TOUR_DEFAULT_HEADCOUNT'];
			$param['S_MAX']			= $t_row['TOUR_DEFAULT_MAX'];
			$param['S_MINI']		= $t_row['TOUR_DEFAULT_MINI'];
			$param['S_THREE']		= $t_row['TOUR_DEFAULT_THREE'];
			$param['S_FIVE']		= $t_row['TOUR_DEFAULT_FIVE'];
			$param['S_ODD']			= $t_row['TOUR_DEFAULT_ODD'];
		}
		
		$tirle_str = $param['MODE'] == "edit" ? "日程の編集" : "日程の登録";
		
		$view = new Smarty_View($this->module);
		
		$view->assign('param', $param);
		$view->assign('title', $tirle_str);
		$view->showPage('template.tpl','ScheduleInput');
    }


 /**
     * 日程データ確認画面表示
     */
    public function scheduleconfirmAction()
    {

		$param = Zend_Controller_Action::_getAllParams();
		
		$tirle_str = $param['MODE'] == "edit" ? "日程の編集" : "日程の登録";
		
		// 入力チェック
		$Message = "";
		
		// 日付
		if(empty($param['S_DATE'])){
			$Message .= "日付を入力してください<br />";
		}elseif($this->strMatching($param['S_DATE'], "DATE")){
			$Message .= "日付は半角数字といくつかの記号でのみ入力してください<br />";
		}//end if
		
		// ツアー価格
		if(empty($param['S_PRICE'])){
			$Message .= "ツアー価格を入力してください<br />";
		}elseif($this->strMatching($param['S_PRICE'], "NUM")){
			$Message .= "ツアー価格は半角数字で入力してください<br />";
		}//end if
		
		// ツアー募集人数
		if(empty($param['S_HEADCOUNT'])){
			$Message .= "ツアー募集人数を入力してください<br />";
		}elseif($this->strMatching($param['S_HEADCOUNT'], "NUM")){
			$Message .= "ツアー募集人数は半角数字で入力してください<br />";
		}//end if
		
		// ツアー最大人数
		if(empty($param['S_MAX'])){
			$Message .= "ツアー最大人数を入力してください<br />";
		}elseif($this->strMatching($param['S_MAX'], "NUM")){
			$Message .= "ツアー最大人数は半角数字で入力してください<br />";
		}//end if
		
		// ツアー最少人数
		if(empty($param['S_MINI'])){
			$Message .= "ツアー最少人数を入力してください<br />";
		}elseif($this->strMatching($param['S_MINI'], "NUM")){
			$Message .= "ツアー最大人数は半角数字で入力してください<br />";
		}//end if
		
		if (!empty($Message)) 
		{// 入力NG
		
			$view = new Smarty_View($this->module);
			$view->assign("Message", $Message);
			$view->assign("param", $param);
			$view->assign('title', $tirle_str);
			$view->showPage('template.tpl','ScheduleInput');
			return false;
		}
		
		$view = new Smarty_View($this->module);
		$view->assign('title', $tirle_str);
		$view->assign('param', $param);
		$view->showPage('template.tpl','ScheduleConfirm');

    }

    /**
     * 日程insertアクション
     */
    public function scheduleinsertAction()
    {
         $param = Zend_Controller_Action::_getAllParams();
	
	 //CHECK & SET PARAM CLASS 
	//TEMP EASY CHECK 2008/12/22

	//SET PARAM
	
        $row = array (
		'TOUR_ID' 	=> $param['T_ID'],
		'CREATE_TIME'	=> date('Y/m/d H:i:s')
                 );

	if(!empty($param['S_DATE'])){
		$row['SCHEDULE_DATE'] 	= $param['S_DATE'];
	}//end if

	if(!empty($param['S_PRICE'])){
		$row['SCHEDULE_PRICE']	= $param['S_PRICE'];
	}//end if

	if(!empty($param['S_HEADCOUNT'])){
		$row['SCHEDULE_DEFAULT_HEADCOUNT'] = $param['S_HEADCOUNT'];
		$row['SCHEDULE_HEADCOUNT'] = $param['S_HEADCOUNT'];
	}//end if

	if(!empty($param['S_MAX'])){
		$row['SCHEDULE_MAX']	= $param['S_MAX'];
	}//end if

	if(!empty($param['S_MINI'])){
		$row['SCHEDULE_MINI']	= $param['S_MINI'];
	}//end if

	if(!empty($param['S_THREE'])){
		$row['SCHEDULE_THREE'] 	= $param['S_THREE'];
	}//end if

	if(!empty($param['S_FIVE'])){
		$row['SCHEDULE_FIVE']		= $param['S_FIVE'];
	}//end if

	if(!empty($param['S_ODD'])){
		$row['SCHEDULE_ODD']		= $param['S_ODD'];
	}//end if
		
		$row['SCHEDULE_THREE']	= isset($row['SCHEDULE_THREE']) ? "1" : "0";
		$row['SCHEDULE_FIVE']	= isset($row['SCHEDULE_FIVE']) ? "1" : "0";
		$row['SCHEDULE_ODD']	= isset($row['SCHEDULE_ODD']) ? "1" : "0";
		
		// 翌日算出
		$a = explode("-", $param['S_DATE']);
		$a = !isset($a[2]) ? explode("/", $param['S_DATE']) : $a;
		$next_date = date("Y-m-d", mktime(0, 0, 0, $a[1], $a[2]+1, $a[0]));
/*
echo "<PRE>";
var_dump($row);
echo "</PRE>";
*/
        // 行の挿入

        $tour = new Tour_Schedule();
        $key=$tour->insert($row);
/*
echo "{$key}  が登録されました<P>";
echo "{$param['controller']}<P>";
*/
//View 
        $view = new Smarty_View($this->module);
        $view->assign('title', '日程の登録');
        $view->assign('param', $param);
        $view->assign('next_date', $next_date);
        $view->showPage('template.tpl','ScheduleComplete');

        //$this->_redirect("/{$this->module}/{$this->controller}");
    }
	/**
	 * 日程updateアクション
	 */
	public function scheduleupdateAction()
	{
	
		$param = Zend_Controller_Action::_getAllParams();
		
		$row = array (
				'TOUR_ID' 	=> $param['T_ID'],
				'UPDATE_TIME'	=> date('Y/m/d H:i:s')
				);
		
		if(!empty($param['S_DATE'])){
			$row['SCHEDULE_DATE'] 	= $param['S_DATE'];
		}//end if
		
		if(!empty($param['S_PRICE'])){
			$row['SCHEDULE_PRICE']	= $param['S_PRICE'];
		}//end if
		
		if(!empty($param['S_HEADCOUNT'])){
			$row['SCHEDULE_DEFAULT_HEADCOUNT'] = $param['S_HEADCOUNT'];
//			$row['SCHEDULE_HEADCOUNT'] = $param['S_HEADCOUNT'];
//$t="(".$param['S_HEADCOUNT'] . " - SCHEDULE_DEFAULT_HEADCOUNT + SCHEDULE_HEADCOUNT)";
//$t="NULL";
//			$row['SCHEDULE_HEADCOUNT'] = new Zend_Db_Expr($t);
			$row['SCHEDULE_HEADCOUNT'] = "SCHEDULE_HEADCOUNT + 1";
		}//end if
		
		if(!empty($param['S_MAX'])){
			$row['SCHEDULE_MAX']	= $param['S_MAX'];
		}//end if
		
		if(!empty($param['S_MINI'])){
			$row['SCHEDULE_MINI']	= $param['S_MINI'];
		}//end if
		
		if(!empty($param['S_THREE'])){
			$row['SCHEDULE_THREE'] 	= $param['S_THREE'];
		}//end if
		
		if(!empty($param['S_FIVE'])){
			$row['SCHEDULE_FIVE']		= $param['S_FIVE'];
		}//end if
		
		if(!empty($param['S_ODD'])){
			$row['SCHEDULE_ODD']		= $param['S_ODD'];
		}//end if
		
		$row['SCHEDULE_THREE']	= isset($row['SCHEDULE_THREE']) ? "1" : "0";
		$row['SCHEDULE_FIVE']	= isset($row['SCHEDULE_FIVE']) ? "1" : "0";
		$row['SCHEDULE_ODD']	= isset($row['SCHEDULE_ODD']) ? "1" : "0";
//var_dump($row);exit();
		
		// 行の更新
		
		$tour = new Tour_Schedule();
		$db = $tour->getAdapter();
		$set = $row;
		$where = array(
					$db->quoteInto('TOUR_ID = ?', $param['T_ID']),
					$db->quoteInto('SCHEDULE_ID = ?', $param['SCHEDULE_ID'])
					);
		$key = $tour->update($set, $where);
		
		$view = new Smarty_View($this->module);
		$view->assign('title', '日程の編集');
		$view->assign('param', $param);
		$view->showPage('template.tpl','ScheduleComplete');
	}

    /**
     * updateアクション
     */
/*    public function updateAction()
    {
        $param = Zend_Controller_Action::_getAllParams();
        // 指定したidの行を更新
        $mssg = new Tour();
        $row = array ('id'  => $param['id'],
                      'title'  => $param['title'],
                      'content'=> $param['content']
                      );
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $key = $mssg->update($row, $where);

        $this->_redirect("/{$this->module}/{$this->controller}/index/key/{$key}");
    }
*/
    /**
     * deleteアクション
     */
/*    public function deleteAction()
    {
        $param = Zend_Controller_Action::_getAllParams();
        // 指定したidの行を削除
        $mssg = new Tour();
        $db = $mssg->getAdapter();
        $where = $db->quoteInto('id = ?', $param['id']);
        $mssg->delete($where);

        $this->_redirect("/{$this->module}/{$this->controller}/");
    }
*/
	/**
	 * URL生成画面表示アクション
	 */
	public function toururlAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$rese = new Tour();
		$db = $rese->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$row = $rese->fetchRow($where)->toArray();
		
		$param['TOUR_CODE']	= $row['TOUR_CODE'] ? $row['TOUR_CODE'] : "";
		$param['TOUR_NAME']	= $row['TOUR_NAME'] ? $row['TOUR_NAME'] : "";
		$param['TOUR_URL']	= $row['TOUR_URL'] ? $row['TOUR_URL'] : "http://*****/";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', 'URL表示');
		$view->showPage('template.tpl','TourURL');
	}

	/**
	 * ツアー情報削除確認画面表示アクション
	 */
	public function tourdeleteconfAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$rese = new Tour();
		$db = $rese->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$row = $rese->fetchRow($where)->toArray();
		
		$param['TOUR_CODE']	= $row['TOUR_CODE'] ? $row['TOUR_CODE'] : "";
		$param['TOUR_NAME']	= $row['TOUR_NAME'] ? $row['TOUR_NAME'] : "";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', 'ツアー削除');
		$view->showPage('template.tpl','TourDeleteConfirm');
	}

	/**
	 * ツアー情報削除アクション
	 */
	public function tourdeleteAction()
	{
	
		$param = Zend_Controller_Action::_getAllParams();
		
		$rese = new Tour();
		$db = $rese->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$rese->delete($where);
		
		$get_param = "?T_STR=" . urlencode($param['TOUR_NAME']);
		
		$this->_redirect("/{$this->module}/{$this->controller}/tourdeletecomp".$get_param);
	}

	/**
	 * ツアー情報削除完了画面表示アクション
	 */
	public function tourdeletecompAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$param['TOUR_NAME']	= $param['T_STR'] ? $param['T_STR'] : "";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', 'ツアー削除');
		$view->showPage('template.tpl','TourDeleteComplete');
	}

	/**
	 * 日程一覧表示画面アクション
	 */
	public function scheduleselectAction()
	{

		// 全ての行を取得
		$param = Zend_Controller_Action::_getAllParams();
		
		$tour = new Tour_Schedule();
		$db = $tour->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$order = "SCHEDULE_DATE ASC";
		$rows = $tour->fetchAll($where, $order);
		
		$rese = new Tour();
		$db = $rese->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$row = $rese->fetchRow($where)->toArray();
		
		//Smartyに連想配列を渡す（assignする）
		$view = new Smarty_View($this->module);
		$view->assign("params", $param);
		$view->assign("param", $rows);
		$view->assign("tour", $row);
		$view->assign('title', '日程編集');
		$view->showPage('template.tpl','ScheduleSelect');
	}

	/**
	 * 日程情報削除確認画面表示アクション
	 */
	public function scheduledeleteconfAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$rese = new Tour();
		$db = $rese->getAdapter();
		$where = $db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']);
		$row = $rese->fetchRow($where);
		
		$param['TOUR_CODE']	= $row['TOUR_CODE'] ? $row['TOUR_CODE'] : "";
		$param['TOUR_NAME']	= $row['TOUR_NAME'] ? $row['TOUR_NAME'] : "";
		
		$rese = new Tour_Schedule();
		$db = $rese->getAdapter();
		$where = array(
					$db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']),
					$db->quoteInto('SCHEDULE_ID = ?', $param['SCHEDULE_ID'])
					);
		$row = $rese->fetchRow($where);
		
		$param['SCHEDULE_ID']	= $row['SCHEDULE_ID'] ? $row['SCHEDULE_ID'] : "";
		$param['SCHEDULE_DATE']	= $row['SCHEDULE_DATE'] ? $row['SCHEDULE_DATE'] : "";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', '日程削除');
		$view->showPage('template.tpl','ScheduleDeleteConfirm');
	}

	/**
	 * 日程情報削除アクション
	 */
	public function scheduledeleteAction()
	{
	
		$param = Zend_Controller_Action::_getAllParams();
		
		$rese = new Tour_Schedule();
		$db = $rese->getAdapter();
		$where = array(
					$db->quoteInto('TOUR_ID = ?', $param['TOUR_ID']),
					$db->quoteInto('SCHEDULE_ID = ?', $param['SCHEDULE_ID'])
					);
		$rese->delete($where);
		
		$get_param  = "?T_STR=" . urlencode($param['TOUR_NAME']);
		$get_param .= "&S_DATE=" . $param['SCHEDULE_DATE'];
		$get_param .= "&TOUR_ID=" . $param['TOUR_ID'];
		
		$this->_redirect("/{$this->module}/{$this->controller}/Scheduledeletecomp".$get_param);
	}

	/**
	 * 日程情報削除完了画面表示アクション
	 */
	public function scheduledeletecompAction()
	{

		$param = Zend_Controller_Action::_getAllParams();
		
		$param['TOUR_NAME']		= $param['T_STR'] ? $param['T_STR'] : "";
		$param['SCHEDULE_DATE']	= $param['S_DATE'] ? $param['S_DATE'] : "";
		
		$view = new Smarty_View($this->module);
		$view->assign("param", $param);
		$view->assign('title', '日程削除');
		$view->showPage('template.tpl','ScheduleDeleteComplete');
	}


	/**
	 * 入力チェック
	 */
	public function strMatching($str, $key){
	
		$pattern = array(
					// 半角数字
					'NUM'		=> array(
								'^[0-9]+$',
								'半角数字のみです',
								),
					// 半角英数字
					'NUM_ABC'	=> array(
								'^[a-zA-Z0-9]+$',
								'半角英数字のみです',
								),
					// 半角英数字＋半角記号
					'ABC_KIGOU'	=> array(
								'^[a-zA-Z0-9,_~./]+$',
								'半角英数字といくつかの半角記号類のみです',
								),
					// 全角カタカナ
					'KANA_ZEN'	=> array(
								'^[ア-ンヴァィゥェォー]+$',
								'全角カタカナのみです',
								),
					// 半角カタカナ
					'KANA_HAN'	=> array(
								'^[ｱ-ﾝﾞﾟ]+$',
								'半角カタカナのみです',
								),
					// URL
					'URL'		=> array(
								'^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]*)$',
								'URLの形式。例: http://www.yourname.jp/',
								),
					// E-mail
					'EMAIL'		=> array(
								'^[a-zA-Z0-9_\.,-]+@([a-zA-Z0-9_\.,-]+\.[a-zA-Z0-9]+$)',
								'メールアドレスの形式。例: yourname@yourname.com',
								),
					// 日付
					'DATE'		=> array(
								'^[0-9\-\/]+$',
								'半角数字といくつかの半角記号類のみです',
								),
					);
					
		if(isset($pattern[$key])){
			$match = $pattern[$key][0];
			if(!mb_ereg($match, $str))
				return $pattern[$key][1];
		}
	}

    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        header('HTTP/1.1 404 Not found');
	throw new Exception('例外です');
        $view = new My_View();
        $view->pageTitle = '404 Not found';
        $view->content = '指定ページが見つかりません';
        $view->showPage();
    }
}



