<?php
require_once 'Zend/Controller/Action.php';
require_once 'Zend/Config/Ini.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Table.php';


require_once HIS_APP . 'models/Tour.php';
require_once HIS_APP.'lib/Smarty/View.php';
require_once HIS_APP.'lib/Mobile/Carrier.php';

class Front_IndexController extends Zend_Controller_Action 
{
public $module;
public $controller;
public $CARRIER=array();
public $base_url;
public $top_url;

    /**
     * initアクション
     */
    public function init()
    {
		$req = $this->getRequest();

		$this->module     = $req->getModuleName();
		$this->controller = $req->getControllerName();

			//BASE_URL 取得
				$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
				$this->base_url =	$config->site->url;//configに定義
				$this->top_url  =	$config->top->url;//configに定義

		$carrier = new Carrier;

		$this->CARRIER = $carrier->mobile_carrier();


/*
echo "CARRIER carrier------------>{$this->CARRIER[0]}<P>";
echo "CARRIER model------------>{$this->CARRIER[1]}<P>";
echo "CARRIER type------------>{$this->CARRIER[2]}<P>";

echo "module------------>{$req->getModuleName()}<P>";
echo "ctrl------------>{$req->getControllerName()}<P>";
echo "action------------>{$req->getActionName()}<P>";
*/
    }

    /**
     * ツアー情報を表示する
     */
    public function indexAction()
    {
        $param = Zend_Controller_Action::_getAllParams();

/*
echo "<PRE>";
var_dump($param);
echo "</pre>";
*/

	$view = new Smarty_View($this->module);

     //echo "T_ID------------>{$param['T_ID']}<P>";

       // 指定したidのツアー情報を取得

				if(!empty($param['T_ID'])){
        $tour = new Tour();
        $db = $tour->getAdapter();

				$sql="SELECT COUNT(*) FROM M_TOURPACKAGE WHERE TOUR_ID={$param['T_ID']}";
				
				$t_count = $db->fetchOne($sql);

				if(!$t_count){
	 					$view->assign("title", "ツアー選択エラー");
	 					$view->assign("Message", "SELECT_ERROR");
    				$view->showPage('template.tpl','Message',$this->CARRIER[0]);
						exit();
				}//end


        $where = $db->quoteInto('TOUR_ID= ?', $param['T_ID']);
        $row = $tour->fetchRow($where)->toArray();

				}//end if

	
	$view->assign("param", $row);

	if(!empty($param['SESS_ID'])){
		$view->assign("SESS_ID", $param['SESS_ID']);
	}//end if

	if(!empty($param['S_CHANGE'])){
		$view->assign("S_CHANGE", $param['S_CHANGE']);
	}//end if

			$view->assign("TOUR_URL", $row['TOUR_URL']);
	 		$view->assign("BASE_URL", $this->base_url);
	 		$view->assign("TOP_URL", $this->top_url);
			$view->assign("CARRIER", $this->CARRIER[0]);

/*
echo "<PRE>";
var_dump($row);
echo "</pre>";
*/

	//有効期間チェック　エラーの場合はメッセージを表示
	$flg = $this->available_days($row['AVAILABLE_DAYS_FROM'],$row['AVAILABLE_DAYS_TO']);

	//日程データの表示
        $sche = new Tour_Schedule();
        $db = $sche->getAdapter();
/*
        $where = $db->quoteInto('TOUR_ID= ?', $param['T_ID']);
        $row2 = $sche->fetchRow($where)->toArray();
*/

	$config = new Zend_Config_Ini(HIS_APP .'config/config.ini', 'production');
	$dd = $this->computeDate($config->display_date_after);

//echo "ADD DATE --->{$dd}<P>";

/*****/
//ツアー日程のないツアーは選択エラー
				$sql="SELECT COUNT(*) FROM M_TOURPACKAGE_SCHEDULE 
		WHERE TOUR_ID={$param['T_ID']} AND '{$dd}' <= SCHEDULE_DATE ORDER BY SCHEDULE_DATE";

				$t_count = $db->fetchOne($sql);

				if(!$t_count){
	 					$view->assign("title", "ツアー選択エラー");
	 					$view->assign("Message", "SELECT_ERROR");
    				$view->showPage('template.tpl','Message',$this->CARRIER[0]);
						exit();
				}//end

/*****/


	$sql="SELECT * FROM M_TOURPACKAGE_SCHEDULE 
		WHERE TOUR_ID={$param['T_ID']} AND '{$dd}' <= SCHEDULE_DATE ORDER BY SCHEDULE_DATE";
//echo "SQL--->{$sql}<P>";
        $row2 = $db->fetchAll($sql);

/*
echo "<PRE>";
var_dump($row2);
echo "</pre>";
*/

	$view->assign("T_ID", $param['T_ID']);
	if(!empty($param['SESS_ID'])){
		$view->assign("SESS_ID", $param['SESS_ID']);
	}//end if

	//金額表示のために１００００で割る
	foreach($row2 as $key=>$price){
		$row2[$key]['SCHEDULE_PRICE']=intval($price['SCHEDULE_PRICE'])/10000;
//echo "PRICE --->{$row2[$key]['SCHEDULE_PRICE']}<P>";
	}//end foreach


	$view->assign("param2", $row2);
	$view->assign("CRRIER", $this->CARRIER[0]);

	 if(!$flg){

	 $view->assign("title", "ツアー選択エラー");
	 $view->assign("Message", "SELECT_ERROR");
    $view->showPage('template.tpl','Message',$this->CARRIER[0]);

		}else{
        $view->showPage('template.tpl','FrontIndex',$this->CARRIER[0]);
		}//end if

    }//end function




    /**
     * 日付足し算
     */
	public function computeDate($addDays) {
	  $year =date('Y');
	  $month=date('m'); 
	  $day = date('d');

    		$baseSec = mktime(0, 0, 0, $month, $day, $year);//基準日を秒で取得
    		$addSec = $addDays * 86400;//日数×１日の秒数
    		$targetSec = $baseSec + $addSec;
    		return date("Y-m-d", $targetSec);
	}

     /**
     * 有効期間チェック
     */
	public function available_days($from,$to){

	$flg= TRUE;
/*
echo "time()----->".time()."<P>";
echo "from----->".strtotime($from)."<P>";
echo "to----->".strtotime($to)."<P>";
*/

	if(!empty($from) && !empty($to) ){//from to 両方ある
		if( (time() < strtotime($from) ) || ( strtotime($to) < time()  ) ){
			$flg = FALSE;
			//echo "ERROR----1<P>";
		}//end if
	}else if(!empty($from) ){//fromがある
		if( time() < strtotime($from) ){
			$flg = FALSE;
			//echo "ERROR----2<P>";
		}//end if
	}else if( !empty($to) ){//toがある
		if( strtotime($to) < time() ){
			$flg = FALSE;
			//echo "ERROR----3<P>";
		}//end if
	}else{
			//echo "OK----4<P>";
	}//end if


		return($flg);

//die('===STOP===');

	}//end function


    /**
     * アクション名が見つからない
     */
    public function __call($methodName, $args)
    {
        $param = Zend_Controller_Action::_getAllParams();
        $this->_redirect("/{$param['controller']}/");
    }
}
